package io.zipcoder.interfaces;

import java.lang.reflect.Array;
import java.util.ArrayList;

public abstract class People<E extends Person> {

    private ArrayList<E> personList;

    public People() {
        this.personList = new ArrayList<E>();
    }

    class anonymousSubClass extends People {}

    public void add(E person) {
        personList.add(person);
    }

    public void remove(E person) {
        for (E element : personList) {
            if (element.equals(person)) {
                personList.remove(element);
                break;
            }
        }
    }

    public void removeById(long id) {
        for (E element : personList) {
            if (element.getID() == id) {
                personList.remove(element);
                break;
            }
        }
    }

    public E findById(long id) {
        E person = null;
        for (E element : personList) {
            if (element.getID() == id) {
                person = element;
                break;
            }
        }
        return person;
    }



//    public E[] getArray() {
//        ArrayList<E> personArray = new ArrayList<E>();
//        for (E element : personList) {
//            personArray.add(element);
//        }
//        return personArray.toArray(new E[personList.size()]);
//    }



//    public E[] getArray() {
//        E[] genericArray = (E[]) Array.newInstance(People[].class.getComponentType(), personList.size());
//        // person array
//        System.out.println(genericArray);
//        // people array
//        System.out.println(Array.newInstance(People[].class.getComponentType(), personList.size()));
//        return null;
//    }

    public ArrayList<E> getArray() {
        ArrayList<E> personArray = new ArrayList<E>();
        for (E element : personList) {
            personArray.add(element);
        }
        return personArray;
    }

    public void removeAll() {
        personList = new ArrayList<E>();
    }

    public E getPerson(int index) {
        return personList.get(index);
    }

    public int getCount() {
        return personList.size();
    }
}

