package io.zipcoder.interfaces;

import java.util.ArrayList;

public final class ZipCodeWilmington {

    private final static ZipCodeWilmington instance = new ZipCodeWilmington();

    public Students students = Students.getInstance();
    public Instructors instructors = Instructors.getInstance();
    ArrayList<Student> cohortList = students.studentList;

    public void hostLecture(Teacher teacher, double numberOfHours){
        Learner[] cohort = cohortList.toArray(new Learner[cohortList.size()]);

        teacher.lecture(cohort, numberOfHours);
    }

    public void hostLecture(long id, double numberOfHours){
        Instructor instructor = null;

        for (Instructor element : instructors.instructorsList) {
            if (element.getID() == id) {
                instructor = element;
            }
        }

        Learner[] cohort = cohortList.toArray(new Learner[cohortList.size()]);

        instructor.lecture(cohort, numberOfHours);
    }



    private ZipCodeWilmington() {
    }

    public static ZipCodeWilmington getInstance() {
        return instance;
    }


}
