package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class EducatorTest {

    Student student = new Student(1, "Baby Code");
    Student[] students = new Student[3];

    @Before
    public void populateStudents() {
        students[0] = new Student(1, "Baby Code");
        students[1] = new Student(2, "Babier Code");
        students[2] = new Student(3, "Babiest Code");
    }

    @Test
    public void testImplementation() {
        boolean expected = true;
        boolean actual = Educator.KRIS instanceof Teacher;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testTeach() {
        Educator.KRIS.setTimeWorked(0);
        Educator.KRIS.teach(student, 3);

        double expected = 3;
        double actual = student.getTotalStudyTime();

        Assert.assertEquals(expected, actual, 0.1);
    }

    @Test
    public void testLecture() {
        Educator.KRIS.setTimeWorked(0);
        Educator.KRIS.lecture(students, 9);

        double expected = 3;
        double actual = students[0].getTotalStudyTime();

        Assert.assertEquals(expected, actual, 0.1);
    }

    @Test
    public void testLecture_Time() {
        Educator.KRIS.setTimeWorked(0);
        Educator.KRIS.lecture(students, 9);

        double expected = 9;
        double actual = Educator.KRIS.getTimeWorked();

        Assert.assertEquals(expected, actual, 0.1);
    }

    @Test
    public void testLecture_SoloTime() {
        Educator.KRIS.setTimeWorked(0);
        Educator.NHU.lecture(students, 9);

        double nhuActual = Educator.NHU.getTimeWorked();
        double krisActual = Educator.KRIS.getTimeWorked();

        Assert.assertNotEquals(nhuActual, krisActual, 0.1);
    }
}
