package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class InstructorTest {

    Instructor instructor = new Instructor(10, "Professor Code");
    Student student = new Student(1, "Baby Code");
    Student[] students = new Student[5];

    @Before
    public void populateStudents() {
        students[0] = new Student(1, "Baby Code");
        students[1] = new Student(2, "Babier Code");
        students[2] = new Student(3, "Babiest Code");
        students[3] = new Student(4, "Infant Code");
        students[4] = new Student(5, "Fetus Code");
    }

    @Test
    public void testImplementation() {
        boolean expected = true;
        boolean actual = instructor instanceof Teacher;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testInheritance(){
        boolean expected = true;
        boolean actual = instructor instanceof Person;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testTeach() {
        instructor.teach(student, 10);

        double expected = 10;
        double actual = student.getTotalStudyTime();

        Assert.assertEquals(expected, actual, 0.1);
    }

    @Test
    public void testLecture() {
        instructor.lecture(students, 50);

        double expected = 10;
        double actual = students[0].getTotalStudyTime();

        Assert.assertEquals(expected, actual, 0.1);
    }
}
