package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;

public class PeopleTest {

    People people = new People() {};
    Instructor instructor = new Instructor(10, "Professor Code");
    Student student1 = new Student(1, "Baby Code");
    Student student2 = new Student(2, "Babier Code");

    @Before
    public void populatePeople() {
        people.add(instructor);
        people.add(student1);
        people.add(student2);
    }

    @Test
    public void testAdd() {
        boolean expected = true;
        boolean actual = people.getPerson(0) instanceof Person;

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetCount() {
        int expected = 3;
        int actual = people.getCount();

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveByPerson_Count() {
        people.remove(student1);

        int expected = 2;
        int actual = people.getCount();

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveByPerson_Person() {
        people.remove(instructor);

        Object expected = student1;
        Object actual = people.getPerson(0);

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveById_Count () {
        people.removeById(10);

        int expected = 2;
        int actual = people.getCount();

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveById_Person () {
        people.removeById(10);

        Object expected = student1;
        Object actual = people.getPerson(0);

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testFindById () {
        Object expected = instructor;
        Object actual = people.findById(10);

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testGetArray() {
        ArrayList<Person> expected = new ArrayList<Person>();
        expected.add(instructor);
        expected.add(student1);
        expected.add(student2);

        ArrayList<Person> actual = people.getArray();

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveAll() {
        people.removeAll();

        int expected = 0;
        int actual = people.getCount();

        Assert.assertEquals(expected, actual);
    }
}
